package com.tzld.piaoquan.growth.common.model.po;

import com.tzld.piaoquan.growth.common.utils.page.Page;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class StaffGroupStatisticsTotalExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    protected Page page;

    public StaffGroupStatisticsTotalExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setPage(Page page) {
        this.page=page;
    }

    public Page getPage() {
        return page;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andDateIsNull() {
            addCriterion("`date` is null");
            return (Criteria) this;
        }

        public Criteria andDateIsNotNull() {
            addCriterion("`date` is not null");
            return (Criteria) this;
        }

        public Criteria andDateEqualTo(String value) {
            addCriterion("`date` =", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateNotEqualTo(String value) {
            addCriterion("`date` <>", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateGreaterThan(String value) {
            addCriterion("`date` >", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateGreaterThanOrEqualTo(String value) {
            addCriterion("`date` >=", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateLessThan(String value) {
            addCriterion("`date` <", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateLessThanOrEqualTo(String value) {
            addCriterion("`date` <=", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateLike(String value) {
            addCriterion("`date` like", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateNotLike(String value) {
            addCriterion("`date` not like", value, "date");
            return (Criteria) this;
        }

        public Criteria andDateIn(List<String> values) {
            addCriterion("`date` in", values, "date");
            return (Criteria) this;
        }

        public Criteria andDateNotIn(List<String> values) {
            addCriterion("`date` not in", values, "date");
            return (Criteria) this;
        }

        public Criteria andDateBetween(String value1, String value2) {
            addCriterion("`date` between", value1, value2, "date");
            return (Criteria) this;
        }

        public Criteria andDateNotBetween(String value1, String value2) {
            addCriterion("`date` not between", value1, value2, "date");
            return (Criteria) this;
        }

        public Criteria andCorpIdIsNull() {
            addCriterion("corp_id is null");
            return (Criteria) this;
        }

        public Criteria andCorpIdIsNotNull() {
            addCriterion("corp_id is not null");
            return (Criteria) this;
        }

        public Criteria andCorpIdEqualTo(Long value) {
            addCriterion("corp_id =", value, "corpId");
            return (Criteria) this;
        }

        public Criteria andCorpIdNotEqualTo(Long value) {
            addCriterion("corp_id <>", value, "corpId");
            return (Criteria) this;
        }

        public Criteria andCorpIdGreaterThan(Long value) {
            addCriterion("corp_id >", value, "corpId");
            return (Criteria) this;
        }

        public Criteria andCorpIdGreaterThanOrEqualTo(Long value) {
            addCriterion("corp_id >=", value, "corpId");
            return (Criteria) this;
        }

        public Criteria andCorpIdLessThan(Long value) {
            addCriterion("corp_id <", value, "corpId");
            return (Criteria) this;
        }

        public Criteria andCorpIdLessThanOrEqualTo(Long value) {
            addCriterion("corp_id <=", value, "corpId");
            return (Criteria) this;
        }

        public Criteria andCorpIdIn(List<Long> values) {
            addCriterion("corp_id in", values, "corpId");
            return (Criteria) this;
        }

        public Criteria andCorpIdNotIn(List<Long> values) {
            addCriterion("corp_id not in", values, "corpId");
            return (Criteria) this;
        }

        public Criteria andCorpIdBetween(Long value1, Long value2) {
            addCriterion("corp_id between", value1, value2, "corpId");
            return (Criteria) this;
        }

        public Criteria andCorpIdNotBetween(Long value1, Long value2) {
            addCriterion("corp_id not between", value1, value2, "corpId");
            return (Criteria) this;
        }

        public Criteria andStaffIdIsNull() {
            addCriterion("staff_id is null");
            return (Criteria) this;
        }

        public Criteria andStaffIdIsNotNull() {
            addCriterion("staff_id is not null");
            return (Criteria) this;
        }

        public Criteria andStaffIdEqualTo(Long value) {
            addCriterion("staff_id =", value, "staffId");
            return (Criteria) this;
        }

        public Criteria andStaffIdNotEqualTo(Long value) {
            addCriterion("staff_id <>", value, "staffId");
            return (Criteria) this;
        }

        public Criteria andStaffIdGreaterThan(Long value) {
            addCriterion("staff_id >", value, "staffId");
            return (Criteria) this;
        }

        public Criteria andStaffIdGreaterThanOrEqualTo(Long value) {
            addCriterion("staff_id >=", value, "staffId");
            return (Criteria) this;
        }

        public Criteria andStaffIdLessThan(Long value) {
            addCriterion("staff_id <", value, "staffId");
            return (Criteria) this;
        }

        public Criteria andStaffIdLessThanOrEqualTo(Long value) {
            addCriterion("staff_id <=", value, "staffId");
            return (Criteria) this;
        }

        public Criteria andStaffIdIn(List<Long> values) {
            addCriterion("staff_id in", values, "staffId");
            return (Criteria) this;
        }

        public Criteria andStaffIdNotIn(List<Long> values) {
            addCriterion("staff_id not in", values, "staffId");
            return (Criteria) this;
        }

        public Criteria andStaffIdBetween(Long value1, Long value2) {
            addCriterion("staff_id between", value1, value2, "staffId");
            return (Criteria) this;
        }

        public Criteria andStaffIdNotBetween(Long value1, Long value2) {
            addCriterion("staff_id not between", value1, value2, "staffId");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(String value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(String value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(String value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(String value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(String value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLike(String value) {
            addCriterion("user_id like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotLike(String value) {
            addCriterion("user_id not like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<String> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<String> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(String value1, String value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(String value1, String value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andStatTimeIsNull() {
            addCriterion("stat_time is null");
            return (Criteria) this;
        }

        public Criteria andStatTimeIsNotNull() {
            addCriterion("stat_time is not null");
            return (Criteria) this;
        }

        public Criteria andStatTimeEqualTo(Long value) {
            addCriterion("stat_time =", value, "statTime");
            return (Criteria) this;
        }

        public Criteria andStatTimeNotEqualTo(Long value) {
            addCriterion("stat_time <>", value, "statTime");
            return (Criteria) this;
        }

        public Criteria andStatTimeGreaterThan(Long value) {
            addCriterion("stat_time >", value, "statTime");
            return (Criteria) this;
        }

        public Criteria andStatTimeGreaterThanOrEqualTo(Long value) {
            addCriterion("stat_time >=", value, "statTime");
            return (Criteria) this;
        }

        public Criteria andStatTimeLessThan(Long value) {
            addCriterion("stat_time <", value, "statTime");
            return (Criteria) this;
        }

        public Criteria andStatTimeLessThanOrEqualTo(Long value) {
            addCriterion("stat_time <=", value, "statTime");
            return (Criteria) this;
        }

        public Criteria andStatTimeIn(List<Long> values) {
            addCriterion("stat_time in", values, "statTime");
            return (Criteria) this;
        }

        public Criteria andStatTimeNotIn(List<Long> values) {
            addCriterion("stat_time not in", values, "statTime");
            return (Criteria) this;
        }

        public Criteria andStatTimeBetween(Long value1, Long value2) {
            addCriterion("stat_time between", value1, value2, "statTime");
            return (Criteria) this;
        }

        public Criteria andStatTimeNotBetween(Long value1, Long value2) {
            addCriterion("stat_time not between", value1, value2, "statTime");
            return (Criteria) this;
        }

        public Criteria andNewChatCntIsNull() {
            addCriterion("new_chat_cnt is null");
            return (Criteria) this;
        }

        public Criteria andNewChatCntIsNotNull() {
            addCriterion("new_chat_cnt is not null");
            return (Criteria) this;
        }

        public Criteria andNewChatCntEqualTo(Integer value) {
            addCriterion("new_chat_cnt =", value, "newChatCnt");
            return (Criteria) this;
        }

        public Criteria andNewChatCntNotEqualTo(Integer value) {
            addCriterion("new_chat_cnt <>", value, "newChatCnt");
            return (Criteria) this;
        }

        public Criteria andNewChatCntGreaterThan(Integer value) {
            addCriterion("new_chat_cnt >", value, "newChatCnt");
            return (Criteria) this;
        }

        public Criteria andNewChatCntGreaterThanOrEqualTo(Integer value) {
            addCriterion("new_chat_cnt >=", value, "newChatCnt");
            return (Criteria) this;
        }

        public Criteria andNewChatCntLessThan(Integer value) {
            addCriterion("new_chat_cnt <", value, "newChatCnt");
            return (Criteria) this;
        }

        public Criteria andNewChatCntLessThanOrEqualTo(Integer value) {
            addCriterion("new_chat_cnt <=", value, "newChatCnt");
            return (Criteria) this;
        }

        public Criteria andNewChatCntIn(List<Integer> values) {
            addCriterion("new_chat_cnt in", values, "newChatCnt");
            return (Criteria) this;
        }

        public Criteria andNewChatCntNotIn(List<Integer> values) {
            addCriterion("new_chat_cnt not in", values, "newChatCnt");
            return (Criteria) this;
        }

        public Criteria andNewChatCntBetween(Integer value1, Integer value2) {
            addCriterion("new_chat_cnt between", value1, value2, "newChatCnt");
            return (Criteria) this;
        }

        public Criteria andNewChatCntNotBetween(Integer value1, Integer value2) {
            addCriterion("new_chat_cnt not between", value1, value2, "newChatCnt");
            return (Criteria) this;
        }

        public Criteria andChatTotalIsNull() {
            addCriterion("chat_total is null");
            return (Criteria) this;
        }

        public Criteria andChatTotalIsNotNull() {
            addCriterion("chat_total is not null");
            return (Criteria) this;
        }

        public Criteria andChatTotalEqualTo(Integer value) {
            addCriterion("chat_total =", value, "chatTotal");
            return (Criteria) this;
        }

        public Criteria andChatTotalNotEqualTo(Integer value) {
            addCriterion("chat_total <>", value, "chatTotal");
            return (Criteria) this;
        }

        public Criteria andChatTotalGreaterThan(Integer value) {
            addCriterion("chat_total >", value, "chatTotal");
            return (Criteria) this;
        }

        public Criteria andChatTotalGreaterThanOrEqualTo(Integer value) {
            addCriterion("chat_total >=", value, "chatTotal");
            return (Criteria) this;
        }

        public Criteria andChatTotalLessThan(Integer value) {
            addCriterion("chat_total <", value, "chatTotal");
            return (Criteria) this;
        }

        public Criteria andChatTotalLessThanOrEqualTo(Integer value) {
            addCriterion("chat_total <=", value, "chatTotal");
            return (Criteria) this;
        }

        public Criteria andChatTotalIn(List<Integer> values) {
            addCriterion("chat_total in", values, "chatTotal");
            return (Criteria) this;
        }

        public Criteria andChatTotalNotIn(List<Integer> values) {
            addCriterion("chat_total not in", values, "chatTotal");
            return (Criteria) this;
        }

        public Criteria andChatTotalBetween(Integer value1, Integer value2) {
            addCriterion("chat_total between", value1, value2, "chatTotal");
            return (Criteria) this;
        }

        public Criteria andChatTotalNotBetween(Integer value1, Integer value2) {
            addCriterion("chat_total not between", value1, value2, "chatTotal");
            return (Criteria) this;
        }

        public Criteria andChatHasMsgIsNull() {
            addCriterion("chat_has_msg is null");
            return (Criteria) this;
        }

        public Criteria andChatHasMsgIsNotNull() {
            addCriterion("chat_has_msg is not null");
            return (Criteria) this;
        }

        public Criteria andChatHasMsgEqualTo(Integer value) {
            addCriterion("chat_has_msg =", value, "chatHasMsg");
            return (Criteria) this;
        }

        public Criteria andChatHasMsgNotEqualTo(Integer value) {
            addCriterion("chat_has_msg <>", value, "chatHasMsg");
            return (Criteria) this;
        }

        public Criteria andChatHasMsgGreaterThan(Integer value) {
            addCriterion("chat_has_msg >", value, "chatHasMsg");
            return (Criteria) this;
        }

        public Criteria andChatHasMsgGreaterThanOrEqualTo(Integer value) {
            addCriterion("chat_has_msg >=", value, "chatHasMsg");
            return (Criteria) this;
        }

        public Criteria andChatHasMsgLessThan(Integer value) {
            addCriterion("chat_has_msg <", value, "chatHasMsg");
            return (Criteria) this;
        }

        public Criteria andChatHasMsgLessThanOrEqualTo(Integer value) {
            addCriterion("chat_has_msg <=", value, "chatHasMsg");
            return (Criteria) this;
        }

        public Criteria andChatHasMsgIn(List<Integer> values) {
            addCriterion("chat_has_msg in", values, "chatHasMsg");
            return (Criteria) this;
        }

        public Criteria andChatHasMsgNotIn(List<Integer> values) {
            addCriterion("chat_has_msg not in", values, "chatHasMsg");
            return (Criteria) this;
        }

        public Criteria andChatHasMsgBetween(Integer value1, Integer value2) {
            addCriterion("chat_has_msg between", value1, value2, "chatHasMsg");
            return (Criteria) this;
        }

        public Criteria andChatHasMsgNotBetween(Integer value1, Integer value2) {
            addCriterion("chat_has_msg not between", value1, value2, "chatHasMsg");
            return (Criteria) this;
        }

        public Criteria andNewMemberCntIsNull() {
            addCriterion("new_member_cnt is null");
            return (Criteria) this;
        }

        public Criteria andNewMemberCntIsNotNull() {
            addCriterion("new_member_cnt is not null");
            return (Criteria) this;
        }

        public Criteria andNewMemberCntEqualTo(Integer value) {
            addCriterion("new_member_cnt =", value, "newMemberCnt");
            return (Criteria) this;
        }

        public Criteria andNewMemberCntNotEqualTo(Integer value) {
            addCriterion("new_member_cnt <>", value, "newMemberCnt");
            return (Criteria) this;
        }

        public Criteria andNewMemberCntGreaterThan(Integer value) {
            addCriterion("new_member_cnt >", value, "newMemberCnt");
            return (Criteria) this;
        }

        public Criteria andNewMemberCntGreaterThanOrEqualTo(Integer value) {
            addCriterion("new_member_cnt >=", value, "newMemberCnt");
            return (Criteria) this;
        }

        public Criteria andNewMemberCntLessThan(Integer value) {
            addCriterion("new_member_cnt <", value, "newMemberCnt");
            return (Criteria) this;
        }

        public Criteria andNewMemberCntLessThanOrEqualTo(Integer value) {
            addCriterion("new_member_cnt <=", value, "newMemberCnt");
            return (Criteria) this;
        }

        public Criteria andNewMemberCntIn(List<Integer> values) {
            addCriterion("new_member_cnt in", values, "newMemberCnt");
            return (Criteria) this;
        }

        public Criteria andNewMemberCntNotIn(List<Integer> values) {
            addCriterion("new_member_cnt not in", values, "newMemberCnt");
            return (Criteria) this;
        }

        public Criteria andNewMemberCntBetween(Integer value1, Integer value2) {
            addCriterion("new_member_cnt between", value1, value2, "newMemberCnt");
            return (Criteria) this;
        }

        public Criteria andNewMemberCntNotBetween(Integer value1, Integer value2) {
            addCriterion("new_member_cnt not between", value1, value2, "newMemberCnt");
            return (Criteria) this;
        }

        public Criteria andMemberTotalIsNull() {
            addCriterion("member_total is null");
            return (Criteria) this;
        }

        public Criteria andMemberTotalIsNotNull() {
            addCriterion("member_total is not null");
            return (Criteria) this;
        }

        public Criteria andMemberTotalEqualTo(Integer value) {
            addCriterion("member_total =", value, "memberTotal");
            return (Criteria) this;
        }

        public Criteria andMemberTotalNotEqualTo(Integer value) {
            addCriterion("member_total <>", value, "memberTotal");
            return (Criteria) this;
        }

        public Criteria andMemberTotalGreaterThan(Integer value) {
            addCriterion("member_total >", value, "memberTotal");
            return (Criteria) this;
        }

        public Criteria andMemberTotalGreaterThanOrEqualTo(Integer value) {
            addCriterion("member_total >=", value, "memberTotal");
            return (Criteria) this;
        }

        public Criteria andMemberTotalLessThan(Integer value) {
            addCriterion("member_total <", value, "memberTotal");
            return (Criteria) this;
        }

        public Criteria andMemberTotalLessThanOrEqualTo(Integer value) {
            addCriterion("member_total <=", value, "memberTotal");
            return (Criteria) this;
        }

        public Criteria andMemberTotalIn(List<Integer> values) {
            addCriterion("member_total in", values, "memberTotal");
            return (Criteria) this;
        }

        public Criteria andMemberTotalNotIn(List<Integer> values) {
            addCriterion("member_total not in", values, "memberTotal");
            return (Criteria) this;
        }

        public Criteria andMemberTotalBetween(Integer value1, Integer value2) {
            addCriterion("member_total between", value1, value2, "memberTotal");
            return (Criteria) this;
        }

        public Criteria andMemberTotalNotBetween(Integer value1, Integer value2) {
            addCriterion("member_total not between", value1, value2, "memberTotal");
            return (Criteria) this;
        }

        public Criteria andMemberHasMsgIsNull() {
            addCriterion("member_has_msg is null");
            return (Criteria) this;
        }

        public Criteria andMemberHasMsgIsNotNull() {
            addCriterion("member_has_msg is not null");
            return (Criteria) this;
        }

        public Criteria andMemberHasMsgEqualTo(Integer value) {
            addCriterion("member_has_msg =", value, "memberHasMsg");
            return (Criteria) this;
        }

        public Criteria andMemberHasMsgNotEqualTo(Integer value) {
            addCriterion("member_has_msg <>", value, "memberHasMsg");
            return (Criteria) this;
        }

        public Criteria andMemberHasMsgGreaterThan(Integer value) {
            addCriterion("member_has_msg >", value, "memberHasMsg");
            return (Criteria) this;
        }

        public Criteria andMemberHasMsgGreaterThanOrEqualTo(Integer value) {
            addCriterion("member_has_msg >=", value, "memberHasMsg");
            return (Criteria) this;
        }

        public Criteria andMemberHasMsgLessThan(Integer value) {
            addCriterion("member_has_msg <", value, "memberHasMsg");
            return (Criteria) this;
        }

        public Criteria andMemberHasMsgLessThanOrEqualTo(Integer value) {
            addCriterion("member_has_msg <=", value, "memberHasMsg");
            return (Criteria) this;
        }

        public Criteria andMemberHasMsgIn(List<Integer> values) {
            addCriterion("member_has_msg in", values, "memberHasMsg");
            return (Criteria) this;
        }

        public Criteria andMemberHasMsgNotIn(List<Integer> values) {
            addCriterion("member_has_msg not in", values, "memberHasMsg");
            return (Criteria) this;
        }

        public Criteria andMemberHasMsgBetween(Integer value1, Integer value2) {
            addCriterion("member_has_msg between", value1, value2, "memberHasMsg");
            return (Criteria) this;
        }

        public Criteria andMemberHasMsgNotBetween(Integer value1, Integer value2) {
            addCriterion("member_has_msg not between", value1, value2, "memberHasMsg");
            return (Criteria) this;
        }

        public Criteria andMsgTotalIsNull() {
            addCriterion("msg_total is null");
            return (Criteria) this;
        }

        public Criteria andMsgTotalIsNotNull() {
            addCriterion("msg_total is not null");
            return (Criteria) this;
        }

        public Criteria andMsgTotalEqualTo(Integer value) {
            addCriterion("msg_total =", value, "msgTotal");
            return (Criteria) this;
        }

        public Criteria andMsgTotalNotEqualTo(Integer value) {
            addCriterion("msg_total <>", value, "msgTotal");
            return (Criteria) this;
        }

        public Criteria andMsgTotalGreaterThan(Integer value) {
            addCriterion("msg_total >", value, "msgTotal");
            return (Criteria) this;
        }

        public Criteria andMsgTotalGreaterThanOrEqualTo(Integer value) {
            addCriterion("msg_total >=", value, "msgTotal");
            return (Criteria) this;
        }

        public Criteria andMsgTotalLessThan(Integer value) {
            addCriterion("msg_total <", value, "msgTotal");
            return (Criteria) this;
        }

        public Criteria andMsgTotalLessThanOrEqualTo(Integer value) {
            addCriterion("msg_total <=", value, "msgTotal");
            return (Criteria) this;
        }

        public Criteria andMsgTotalIn(List<Integer> values) {
            addCriterion("msg_total in", values, "msgTotal");
            return (Criteria) this;
        }

        public Criteria andMsgTotalNotIn(List<Integer> values) {
            addCriterion("msg_total not in", values, "msgTotal");
            return (Criteria) this;
        }

        public Criteria andMsgTotalBetween(Integer value1, Integer value2) {
            addCriterion("msg_total between", value1, value2, "msgTotal");
            return (Criteria) this;
        }

        public Criteria andMsgTotalNotBetween(Integer value1, Integer value2) {
            addCriterion("msg_total not between", value1, value2, "msgTotal");
            return (Criteria) this;
        }

        public Criteria andMigrateTraineeChatCntIsNull() {
            addCriterion("migrate_trainee_chat_cnt is null");
            return (Criteria) this;
        }

        public Criteria andMigrateTraineeChatCntIsNotNull() {
            addCriterion("migrate_trainee_chat_cnt is not null");
            return (Criteria) this;
        }

        public Criteria andMigrateTraineeChatCntEqualTo(Integer value) {
            addCriterion("migrate_trainee_chat_cnt =", value, "migrateTraineeChatCnt");
            return (Criteria) this;
        }

        public Criteria andMigrateTraineeChatCntNotEqualTo(Integer value) {
            addCriterion("migrate_trainee_chat_cnt <>", value, "migrateTraineeChatCnt");
            return (Criteria) this;
        }

        public Criteria andMigrateTraineeChatCntGreaterThan(Integer value) {
            addCriterion("migrate_trainee_chat_cnt >", value, "migrateTraineeChatCnt");
            return (Criteria) this;
        }

        public Criteria andMigrateTraineeChatCntGreaterThanOrEqualTo(Integer value) {
            addCriterion("migrate_trainee_chat_cnt >=", value, "migrateTraineeChatCnt");
            return (Criteria) this;
        }

        public Criteria andMigrateTraineeChatCntLessThan(Integer value) {
            addCriterion("migrate_trainee_chat_cnt <", value, "migrateTraineeChatCnt");
            return (Criteria) this;
        }

        public Criteria andMigrateTraineeChatCntLessThanOrEqualTo(Integer value) {
            addCriterion("migrate_trainee_chat_cnt <=", value, "migrateTraineeChatCnt");
            return (Criteria) this;
        }

        public Criteria andMigrateTraineeChatCntIn(List<Integer> values) {
            addCriterion("migrate_trainee_chat_cnt in", values, "migrateTraineeChatCnt");
            return (Criteria) this;
        }

        public Criteria andMigrateTraineeChatCntNotIn(List<Integer> values) {
            addCriterion("migrate_trainee_chat_cnt not in", values, "migrateTraineeChatCnt");
            return (Criteria) this;
        }

        public Criteria andMigrateTraineeChatCntBetween(Integer value1, Integer value2) {
            addCriterion("migrate_trainee_chat_cnt between", value1, value2, "migrateTraineeChatCnt");
            return (Criteria) this;
        }

        public Criteria andMigrateTraineeChatCntNotBetween(Integer value1, Integer value2) {
            addCriterion("migrate_trainee_chat_cnt not between", value1, value2, "migrateTraineeChatCnt");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}